#include "net.h"

//---------------------------------------------------------------------------
int recvfromwait(SOCKET s, char FAR* buf, int len, int flags, struct sockaddr FAR* from, int FAR* fromlen, int timeout)
{
  fd_set rdset;
  struct timeval rdtimeout;
  int received=0;

  FD_ZERO(&rdset);
  FD_SET(s,&rdset);
  rdtimeout.tv_sec=timeout/1000;
  rdtimeout.tv_usec=(timeout%1000)*1000;

  select(0, &rdset, NULL, NULL, &rdtimeout);
  received=recvfrom(s, buf, len, flags, from, fromlen);

  return received;
}

//---------------------------------------------------------------------------
SOCKET udpsocket(void)
{
  int result;
  WORD wVersionRequested;
  WSADATA wsaData;

  SOCKET sockh;
  SOCKADDR_IN listenaddr;

  sockh=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);

  listenaddr.sin_family=AF_INET;
  listenaddr.sin_addr.s_addr=INADDR_ANY;
  listenaddr.sin_port=0;

  result=bind(sockh,(LPSOCKADDR)&listenaddr,sizeof(listenaddr));
  result=WSAGetLastError();

  /* set socket as nonblocking */
  unsigned long fionbio=1;
  ioctlsocket(sockh,FIONBIO,&fionbio);

  return sockh;
}

//---------------------------------------------------------------------------
int udptransact(SOCKET s, SOCKADDR_IN *addr_to, char *data_to, int len_to, char *data_from, int len_from)
{
  int i;

  int sent;
  int received;
  int result;

  SOCKADDR_IN fromaddr;
  int fromadrsiz;

  sent=sendto(s,data_to,len_to,0,(LPSOCKADDR)addr_to,sizeof(SOCKADDR_IN));
  if (sent!=len_to) {
    result=WSAGetLastError();
    return -1;
  }

  fromadrsiz=sizeof(fromaddr);
  received=recvfromwait(s,data_from,len_from,0,(LPSOCKADDR)&fromaddr,&fromadrsiz,200);
  return received;
}

