#include "platform.h"
#include "adc.h"


/* initialize AD converter */
void adc_init(void)
{
  ADCON0=0x00; /* disable ADC */
#if defined(_18F4520) | defined(_18F4620)
  ADCON1=0x0a; /* 5 analog inputs, Vdd and Vss as ref. */
#else /* 18f458 */
  ADCON1=0x02; /* 5 analog inputs, Vdd and Vss as ref. */
#endif
  ADCON0=0x81; /* enable ADC, prescale by 32 */
}


/* select a channel */
void adc_chsel(unsigned char ch)
{
 ADCON0=(ADCON0&0xC7)|(ch<<3);
}


/* start conversion, wait for it to finish and return the sample */
unsigned int adc_convert(void)
{
  GODONE=1; /* set the GO bit */
  while (GODONE); /* wait for nDONE bit */

  return ADRESL|(ADRESH<<8);
}


/* selects a channel, waits for sample acquisition and does the conversion */
unsigned int adc_sample(unsigned char ch)
{
  volatile unsigned char i;
  
  adc_chsel(ch);
  for (i=0; i<20; i++); /* wait several microseconds */
  return adc_convert();
}
