#include <stdio.h>
#include <string.h>

#include "arp.h"
#include "ip.h"


void arp_in(unsigned int len)
{
  struct arp_packet arp;
  unsigned int txbuf;

  if (len<sizeof(struct arp_packet)) return;
  netbuf_read(&arp, sizeof(struct arp_packet));

  if (arp.ptype!=HTONS(0x0800)) return; /* IP protocol only */
  if (arp.hlen!=6) return; /* MAC address is 6 bytes long */
  if (arp.plen!=4) return; /* IP address is 4 bytes long */

  /* we just respond to remote request */
  if (arp.opcode!=HTONS(OP_REQUEST)) return;

  if (arp.target_pa!=myip) return;

  arp.opcode=HTONS(OP_REPLY);

  memmove(arp.target_ha, arp.sender_ha, 6);
  memmove(arp.sender_ha, mymac, 6);

  arp.target_pa=arp.sender_pa;
  arp.sender_pa=myip;

  if (!nic_tx_alloc(&txbuf)) return;
  netbuf_wr_seek(txbuf+ETH_RESERVED,NB_SEEK_SET);
  netbuf_write(&arp, sizeof(struct arp_packet));

  eth_out(NULL, HTONS(ETHTYPE_ARP), txbuf, sizeof(struct arp_packet));
}
