#ifndef arpH
#define arpH

#include "platform.h"
#include "eth.h"


/* ARP packet structure, tailored for IPv4 */
struct arp_packet {
  WORD htype; /* hardware type 1=Ethernet */
  WORD ptype; /* protocol type 0x0800=IP */
  BYTE hlen;  /* hardware address length */
  BYTE plen;  /* protocol address length */
  WORD opcode; /* operation */
  BYTE sender_ha[6];
  DWORD sender_pa;
  BYTE target_ha[6];
  DWORD target_pa;
};


/* ARP opcodes */
#define OP_REQUEST 1
#define OP_REPLY 2


extern void arp_in(unsigned int len);


#endif
