#ifndef dhcpH
#define dhcpH

#include "platform.h"


struct bootp_header {
  BYTE op;
  BYTE htype;
  BYTE hlen;
  BYTE hops;
  DWORD xid;
  WORD seconds;
  WORD flags;
  DWORD clientip;
  DWORD yourip;
  DWORD serverip;
  DWORD gatewayip;
  BYTE clientha[16];
  BYTE server_hostname[64];
  BYTE boot_filename[128];
  BYTE options[];
};


#define BOOTP_OP_BOOTREQUEST 1
#define BOOTP_OP_BOOTREPLY 2

#define BOOTP_HTYPE_ETH 1

#define BOOTP_FLAG_BROADCAST 0x8000

#define DHCP_OPT_MAGIC 0x63825363L
#define DHCP_OPT_MAGIC0 0x63
#define DHCP_OPT_MAGIC1 0x82
#define DHCP_OPT_MAGIC2 0x53
#define DHCP_OPT_MAGIC3 0x63

/* DHCP options */
#define DHCP_PAD 0
#define DHCP_SUBNET_MASK 1
#define DHCP_REQUESTED_IP 50
#define DHCP_MESSAGE_TYPE 53
#define DHCP_SERVER_ID 54
#define DHCP_END 255

/* DHCP message types */
#define DHCPDISCOVER 1
#define DHCPOFFER 2
#define DHCPREQUEST 3
#define DHCPDECLINE 4
#define DHCPACK 5
#define DHCPNAK 6
#define DHCPRELEASE 7


/* current DHCP phase */
extern BYTE dhcp_phase;

/* timeout in seconds */
#define DHCP_TIMEOUT 10

/* DHCP client state machine  */
extern void dhcpc_proc(void);


#endif
