#ifndef ethH
#define ethH

#include "platform.h"
#include "enc28j60.h"

struct eth_header {
  BYTE desta[6]; /* destination MAC address */
  BYTE sourcea[6]; /* source MAC address */
  WORD typelen; /* protocol type or frame length */
  BYTE tail[];
};


/* minimal length of reserved buffer area when sending Ethernet frame */
#define ETH_RESERVED (sizeof(struct eth_header))


/* typelen field values */
#define ETHTYPE_ARP 0x0806
#define ETHTYPE_IP  0x0800

#define ETH_BROADCAST ((void *)0xffff)

/* my MAC address */
extern unsigned char mymac[6];


/* ethernet polling entry point */
extern void eth_proc(void);

/* ethernet packet transmission */
extern void eth_out(BYTE desta[], WORD type, unsigned int txbuf, unsigned int len);

#endif
