#include "platform.h"
#include "timer.h"


volatile clock_t systimer; /* system timer (ms) */


/* in normal mode timer1 is as system timer with one tick per ms */
void timer1_init(void)
{
  T1CON=0x80;
  TMR1H=TMR1_PRELOAD>>8;
  TMR1L=TMR1_PRELOAD&0xff;

  TMR1IF=0; /* clear and enable interrupt */
  TMR1IE=1;

  TMR1ON=1; /* enable the timer */
}


clock_t clock(void)
{
  unsigned int tickcount;
  TMR1IE=0;
  tickcount=systimer;
  TMR1IE=1;
  return tickcount;
}


void delay(unsigned int ms)
{
  clock_t lap;  
  for (lap=clock(); clock()-lap<=ms; );
}
