#ifndef timerH
#define timerH

#include "platform.h"
#include "time.h"

#undef clock
#undef CLOCKS_PER_SEC
#define CLOCKS_PER_SEC 1000

#define TMR1_PERIOD (OSC_FREQ/4/CLOCKS_PER_SEC) /* no prescaler, 1 tick per ms */
#define TMR1_PRELOAD (0x10000-TMR1_PERIOD)


typedef unsigned int clock_t;

extern volatile clock_t systimer;

extern void timer1_init(void);

extern clock_t clock(void);
#define clock_short() ((unsigned char)systimer) /* one byte timer for fast loops */

extern void delay(unsigned int delay_ms);

#endif
